# CubeViz - THE RDF DATACUBE BROWSER 

CubeViz is an [OntoWiki](http://aksw.org/Projects/OntoWiki.html) component providing faceted browsing in statistical 
data in the Linked Data Web. It was set up and adopted to be part of the 
[Data Portal](https://ec.europa.eu/digital-agenda/en/scoreboard) of the European Union. 
CubeViz utilizing the  [RDF DataCube vocabulary](http://www.w3.org/TR/vocab-data-cube/) 
which is the state-of-the-art in representing statistical data in [Resource Description Framework (RDF)](http://www.w3.org/RDF/). 
This vocabulary is compatible with [SDMX](http://en.wikipedia.org/wiki/SDMX) 
([User Guide](http://sdmx.org/wp-content/uploads/2012/11/SDMX_2-1_User_Guide_draft_0-1.pdf)) and increasingly being adopted. 
Based on the vocabulary and the encoded Data Cube, CubeViz is generating a facetted browsing widget that 
can be used to filter interactively observations to be visualized in charts. 
Based on the selected structure, CubeViz offer beneficiary chart types and options which can be selected by users.

Do you want to read further information about the project and its background, please have a look into 
[**about**](https://github.com/AKSW/cubeviz.ontowiki/wiki/About-the-project) page.

![](https://raw.github.com/wiki/AKSW/cubeviz.ontowiki/images/v0.5_IndexActionScreenshot.png)

![](https://raw.github.com/wiki/AKSW/cubeviz.ontowiki/images/v0.6_visualization.png)

## Getting started

You will find various information in our [Wiki](https://github.com/AKSW/cubeviz.ontowiki/wiki/Home).
For new users, please visit Page [installation](https://github.com/AKSW/cubeviz.ontowiki/wiki/Installation-and-setup-main) 
to get an introduction about installation and setup of CubeViz.

Further information about the repository structure or other internals can be also found in the Wiki.

## License

CubeViz is licensed under the terms of GNU General Public License 2 and it uses foreign libraries. 
For further details have a look in [here](https://github.com/AKSW/cubeviz.ontowiki/blob/master/LICENSE.md).
